package io.accumulatenetwork.sdk.generated.managed;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("ReceiptEntry")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ReceiptEntry implements Marshallable {
	private boolean right;
	private byte[] hash;

    //
	public boolean getRight() {
	    return right;
	}
	public void setRight(final boolean value) {
	    this.right = value;
	}

	public ReceiptEntry right(final boolean value) {
	    setRight(value);
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getHash() {
	    return hash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setHash(final byte[] value) {
	    this.hash = value;
	}

	public ReceiptEntry hash(final byte[] value) {
	    setHash(value);
	    return this;
	}
	public ReceiptEntry hash(final String value) {
		try {
			setHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(!this.right)) {
            marshaller.writeBool(1, this.right);
        }
        if (!(this.hash == null || this.hash.length == 0)) {
            marshaller.writeBytes(2, this.hash);
        }
        return marshaller.array();
    }
}
